

/*
    Lightfield for PBRT
 */

#if defined(_MSC_VER)
#pragma once
#endif

#ifndef PBRT_LIGHTFIELD_H
#define PBRT_LIGHTFIELD_H

// core/shape.h*
#include "pbrt.h"
#include "camera.h"
#include "film/lightfield_film.h"

// Lightfield Declaration
class Lightfield : public Camera {
public:
  
    Lightfield( const AnimatedTransform &cam2world, Scene *scene, LightfieldFilm* lfilm,
		float sX, float sY,
		float sopen, float sclose);
    ~Lightfield();
    void setScene(Scene *scene);
    
    float GenerateRay(const CameraSample &s, Ray *ray) const;

    // Lightfield Public Data
    BBox* extWorldBound;
    float sizeX; float sizeY;
    Scene *scene;
};

#endif // PBRT_LIGHTFIELD_H
