
/*
    Lightfield reconstruction.
 */

#if defined(_MSC_VER)
#pragma once
#endif

#ifndef PBRT_LIGHTFIELD_RECONSTUCTION_H
#define PBRT_LIGHTFIELD_RECONSTUCTION_H

// film/lightfield.h*
#include "pbrt.h"
#include "film.h"
#include "sampler.h"
#include "filter.h"
#include "paramset.h"

#include <vector>

// LightfieldReconstruction Declarations
class LightfieldReconstruction {
public:
    // LightfieldReconstruction Public Methods
    LightfieldReconstruction(int xres, int yres,
			      int rAX, int rAY);
    
    virtual ~LightfieldReconstruction();
    virtual void updateSize(int xres, int yres,
			    int rAX, int rAY) = 0;
    
    //Data access
    virtual void GetPixel(const LFSamplePixel &s, float* rgb_val) = 0;

    // LightfieldReconstruction description
    int xResolution, yResolution;
    int resAngleX;
    int resAngleY;
    
};

#endif // PBRT_LIGHTFIELD_RECONSTUCTION_H
