
/*
    Lightfield reconstruction.
 */

#if defined(_MSC_VER)
#pragma once
#endif

#ifndef PBRT_LIGHTFIELD_RECONSTUCTION_DATA_H
#define PBRT_LIGHTFIELD_RECONSTUCTION_DATA_H

// film/lightfield.h*
#include "pbrt.h"
#include "lightfield_reconstruction.h"
#include "sampler.h"
#include "filter.h"
#include "paramset.h"

#include <vector>


// LightfieldReconstructionData Declarations
class LightfieldReconstructionData : public LightfieldReconstruction {
public:
    // LightfieldReconstructionData Public Methods
    LightfieldReconstructionData(int xres, int yres,
				int rAX, int rAY, 
				float* rgb_data);
    
    ~LightfieldReconstructionData();
    
    //Size update
    void updateSize(int xres, int yres,
		    int rAX, int rAY);
    
    //Set float data
    void SetData(float* rgb_data);
    
    //Data access
    void GetPixel(const LFSamplePixel &s, float* rgb_val);
    
    //Output functions
    void WriteImageScanLine(int y, int a_y, string filename);
    void WriteImage(int ax, int ay, string filename);
    
    private:
      
    //Private functions
    int l2px(int x, int y, int ax, int ay);
    
    // Lightfield data
    std::vector<LFSamplePixel> *pixels;
};

#endif // PBRT_LIGHTFIELD_RECONSTUCTION_DATA_H
